<?php
/**
 * Massage Wellness Retreat functions and definitions
 *
 * @package Massage Wellness Retreat
 */

if ( ! defined( 'MASSAGE_WELLNESS_RETREAT_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'MASSAGE_WELLNESS_RETREAT_VERSION', '1.0.0' );
}

function massage_wellness_retreat_setup() {

	load_theme_textdomain( 'massage-wellness-retreat', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'massage-wellness-retreat' ),
			'social-menu' => esc_html__('Social Menu', 'massage-wellness-retreat'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'massage_wellness_retreat_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);
    
    add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'massage_wellness_retreat_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $massage_wellness_retreat_content_width
 */
function massage_wellness_retreat_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'massage_wellness_retreat_content_width', 640 );
}
add_action( 'after_setup_theme', 'massage_wellness_retreat_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function massage_wellness_retreat_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'massage-wellness-retreat' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'massage-wellness-retreat' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'massage-wellness-retreat' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'massage-wellness-retreat' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'massage-wellness-retreat' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'massage-wellness-retreat' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'massage-wellness-retreat' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'massage-wellness-retreat' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'massage_wellness_retreat_widgets_init' );


function massage_wellness_retreat_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

// Font enqueue function
function massage_wellness_retreat_scripts() {
    // Google Fonts
    wp_enqueue_style(
        'massage-wellness-retreat-google-fonts',
        'https://fonts.googleapis.com/css2?family=Cormorant:ital,wght@0,300;0,400;0,500;0,600;0,700;1,300;1,400;1,500;1,600;1,700&family=Montserrat:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap',
        array(),
        null
    );

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-5', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-5/css/all.min.css', array(), '5.15.3');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), '2.3.4');

    // Main stylesheet
    wp_enqueue_style('massage-wellness-retreat-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Add custom inline styles safely
    $custom_style_path = get_parent_theme_file_path('/custom-style.php');
    if (file_exists($custom_style_path)) {
        require $custom_style_path;
        if (!empty($massage_wellness_retreat_custom_css)) {
            wp_add_inline_style('massage-wellness-retreat-style', $massage_wellness_retreat_custom_css);
        }
    }

    // RTL styles if needed
    wp_style_add_data('massage-wellness-retreat-style', 'rtl', 'replace');

    // Navigation script
    wp_enqueue_script('massage-wellness-retreat-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), '2.3.4', true);

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Custom script
    wp_enqueue_script('massage-wellness-retreat-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'massage_wellness_retreat_scripts');

// related post
if (!function_exists('massage_wellness_retreat_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function massage_wellness_retreat_related_post($post_id){        
        $massage_wellness_retreat_categories = get_the_category($post_id);
        if ($massage_wellness_retreat_categories) {
            $massage_wellness_retreat_category_ids = array();
            $massage_wellness_retreat_category = get_category($massage_wellness_retreat_category_ids);
            $massage_wellness_retreat_categories = get_the_category($post_id);
            foreach ($massage_wellness_retreat_categories as $massage_wellness_retreat_category) {
                $massage_wellness_retreat_category_ids[] = $massage_wellness_retreat_category->term_id;
            }
            $count = $massage_wellness_retreat_category->category_count;
            if ($count > 1) { ?>

         	<?php
		$massage_wellness_retreat_related_post_wrap = absint(get_theme_mod('massage_wellness_retreat_enable_related_post', 1));
		if($massage_wellness_retreat_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('massage_wellness_retreat_related_post_text', __('Related Post', 'massage-wellness-retreat'))); ?></h2>
                    <?php
                    $massage_wellness_retreat_cat_post_args = array(
                        'category__in' => $massage_wellness_retreat_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'massage_wellness_retreat_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $massage_wellness_retreat_featured_query = new WP_Query($massage_wellness_retreat_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($massage_wellness_retreat_featured_query->have_posts()) :

                        while ($massage_wellness_retreat_featured_query->have_posts()) : $massage_wellness_retreat_featured_query->the_post();
                            ?>

                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php massage_wellness_retreat_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $massage_wellness_retreat_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/slider1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $massage_wellness_retreat_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        massage_wellness_retreat_posted_on();
                                        massage_wellness_retreat_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('massage_wellness_retreat_related_posts', 'massage_wellness_retreat_related_post', 10, 1);

function massage_wellness_retreat_sanitize_choices( $massage_wellness_retreat_input, $massage_wellness_retreat_setting ) {
    global $wp_customize; 
    $massage_wellness_retreat_control = $wp_customize->get_control( $massage_wellness_retreat_setting->id ); 
    if ( array_key_exists( $massage_wellness_retreat_input, $massage_wellness_retreat_control->choices ) ) {
        return $massage_wellness_retreat_input;
    } else {
        return $massage_wellness_retreat_setting->default;
    }
}

//Excerpt 
function massage_wellness_retreat_excerpt_function($massage_wellness_retreat_excerpt_count = 35) {
    $massage_wellness_retreat_excerpt = get_the_excerpt();
    $massage_wellness_retreat_text_excerpt = wp_strip_all_tags($massage_wellness_retreat_excerpt);
    $massage_wellness_retreat_excerpt_limit = (int) get_theme_mod('massage_wellness_retreat_excerpt_limit', $massage_wellness_retreat_excerpt_count);
    $massage_wellness_retreat_words = preg_split('/\s+/', $massage_wellness_retreat_text_excerpt); 
    $massage_wellness_retreat_trimmed_words = array_slice($massage_wellness_retreat_words, 0, $massage_wellness_retreat_excerpt_limit);
    $massage_wellness_retreat_theme_excerpt = implode(' ', $massage_wellness_retreat_trimmed_words);

    return $massage_wellness_retreat_theme_excerpt;
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$massage_wellness_retreat_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function massage_wellness_retreat_sanitize_checkbox($massage_wellness_retreat_checked)
{
    // Boolean check.
    return ((isset($massage_wellness_retreat_checked) && true == $massage_wellness_retreat_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
    require get_template_directory() . '/revolution/inc/jetpack.php';
}

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

function massage_wellness_retreat_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'massage_wellness_retreat_remove_customize_register', 11 );

/************************************************************************************/
// //////////////////////////////////////////////

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'massage_wellness_retreat_loop_columns');

if (!function_exists('massage_wellness_retreat_loop_columns')) {

	function massage_wellness_retreat_loop_columns() {

		$massage_wellness_retreat_columns = get_theme_mod( 'massage_wellness_retreat_per_columns', 3 );

		return $massage_wellness_retreat_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'massage_wellness_retreat_per_page', 20 );

function massage_wellness_retreat_per_page( $massage_wellness_retreat_cols ) {

  	$massage_wellness_retreat_cols = get_theme_mod( 'massage_wellness_retreat_product_per_page', 9 );

	return $massage_wellness_retreat_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'massage_wellness_retreat_products_args' );

function massage_wellness_retreat_products_args( $massage_wellness_retreat_args ) {

    $massage_wellness_retreat_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $massage_wellness_retreat_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $massage_wellness_retreat_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function massage_wellness_retreat_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --massage_wellness_retreat_logo_width: <?php echo absint(get_theme_mod('massage_wellness_retreat_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('massage_wellness_retreat_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'massage_wellness_retreat_custom_css' );


//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function massage_wellness_retreat_enqueue_function() {

    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/massage_wellness_retreat_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/massage_wellness_retreat_config_file.php';

    define('MASSAGE_WELLNESS_RETREAT_FREE_SUPPORT',__('https://www.revolutionwp.com/products/massage-wellness-retreat','massage-wellness-retreat'));
    define('MASSAGE_WELLNESS_RETREAT_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community','massage-wellness-retreat'));
    define('MASSAGE_WELLNESS_RETREAT_REVIEW',__('https://wordpress.org/support/theme/massage-wellness-retreat/reviews/','massage-wellness-retreat'));
    define('MASSAGE_WELLNESS_RETREAT_BUY_NOW',__('https://www.revolutionwp.com/products/massage-wordpress-theme','massage-wellness-retreat'));
    define('MASSAGE_WELLNESS_RETREAT_LIVE_DEMO',__('https://demo.revolutionwp.com/massage-wellness-retreat-pro/','massage-wellness-retreat'));
    define('MASSAGE_WELLNESS_RETREAT_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/massage-wellness-retreat-pro/','massage-wellness-retreat'));
    define('MASSAGE_WELLNESS_RETREAT_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/massage-wellness-retreat-free/','massage-wellness-retreat'));
    
    if ( ! defined( 'MASSAGE_WELLNESS_RETREAT_PRO_NAME' ) ) {
        define( 'MASSAGE_WELLNESS_RETREAT_PRO_NAME', esc_html__( 'Massage Theme', 'massage-wellness-retreat' ));
    }

    if ( ! defined( 'MASSAGE_WELLNESS_RETREAT_IMPORT_URL' ) ) {
		define( 'MASSAGE_WELLNESS_RETREAT_IMPORT_URL', esc_url( admin_url( 'themes.php?page=massagewellnessretreat-demoimport' ) ) );
	}
	if ( ! defined( 'MASSAGE_WELLNESS_RETREAT_GETSTART_URL' ) ) {
		define( 'MASSAGE_WELLNESS_RETREAT_GETSTART_URL', esc_url( admin_url( 'themes.php?page=massage-wellness-retreat-getstart-page' ) ) );
	}
	if ( ! defined( 'MASSAGE_WELLNESS_RETREAT_WELCOME_MESSAGE' ) ) {
		define( 'MASSAGE_WELLNESS_RETREAT_WELCOME_MESSAGE', __( 'Welcome to Massage Wellness', 'massage-wellness-retreat' ) );
	}
}
add_action( 'after_setup_theme', 'massage_wellness_retreat_enqueue_function' );

// Add admin notice
function massage_wellness_retreat_admin_notice() { 
    global $pagenow;
    $massage_wellness_retreat_theme_args      = wp_get_theme();
    $massage_wellness_retreat_meta            = get_option( 'massage_wellness_retreat_admin_notice' );
    $name            = $massage_wellness_retreat_theme_args->__get( 'Name' );
    $massage_wellness_retreat_current_screen  = get_current_screen();

    if( !$massage_wellness_retreat_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $massage_wellness_retreat_current_screen->base !== 'appearance_page_massage_wellness_retreat_guide' && 
            $massage_wellness_retreat_current_screen->base !== 'toplevel_page_massagewellnessretreat-demoimport' ) { ?>

            <div class="notice notice-success massage-wellness-retreat-welcome-notice">
                <p class="massage-wellness-retreat-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'massage_wellness_retreat_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'massage-wellness-retreat' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="massage-wellness-retreat-welcome-notice-wrap">
                    <h2 class="massage-wellness-retreat-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $massage_wellness_retreat_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'massage-wellness-retreat' ), $massage_wellness_retreat_theme_name ) );
                        ?>
                    </h2>
                    <p class="massage-wellness-retreat-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'massage-wellness-retreat' ); ?>
                    </p>

                    <div class="massage-wellness-retreat-welcome-info">
                        <div class="massage-wellness-retreat-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'massage-wellness-retreat' ); ?>">
                        </div>

                        <div class="massage-wellness-retreat-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'massage-wellness-retreat' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'massage-wellness-retreat' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( MASSAGE_WELLNESS_RETREAT_IMPORT_URL ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'massage-wellness-retreat' ); ?></a></p>
                        </div>

                        <div class="massage-wellness-retreat-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'massage-wellness-retreat' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'massage-wellness-retreat' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( MASSAGE_WELLNESS_RETREAT_GETSTART_URL ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'massage-wellness-retreat' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'massage_wellness_retreat_admin_notice' );

if( ! function_exists( 'massage_wellness_retreat_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function massage_wellness_retreat_update_admin_notice(){
    if ( isset( $_GET['massage_wellness_retreat_admin_notice'] ) && $_GET['massage_wellness_retreat_admin_notice'] = '1' ) {
        update_option( 'massage_wellness_retreat_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'massage_wellness_retreat_update_admin_notice' );


add_action('after_switch_theme', 'massage_wellness_retreat_setup_options');
function massage_wellness_retreat_setup_options () {
    update_option('massage_wellness_retreat_admin_notice', FALSE );
}

// changelog
function massage_wellness_retreat_get_changelog_from_readme() {
    $massage_wellness_retreat_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($massage_wellness_retreat_file_path)) {
        $massage_wellness_retreat_content = file_get_contents($massage_wellness_retreat_file_path);

        // Extract changelog section
        $massage_wellness_retreat_changelog_start = strpos($massage_wellness_retreat_content, "== Changelog ==");
        $massage_wellness_retreat_changelog = substr($massage_wellness_retreat_content, $massage_wellness_retreat_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $massage_wellness_retreat_changelog, $massage_wellness_retreat_matches, PREG_SET_ORDER);
        
        return $massage_wellness_retreat_matches;
    }
    return [];
}

// Helper function to get page ID by slug
function get_page_id_by_slug($massage_wellness_retreat_slug) {
    $massage_wellness_retreat_page = get_page_by_path($massage_wellness_retreat_slug); // Get the page by slug
    return $massage_wellness_retreat_page ? $massage_wellness_retreat_page->ID : 0;   // Return the page ID or 0 if not found
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );